'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSideEffect = require('react-side-effect');

var _reactSideEffect2 = _interopRequireDefault(_reactSideEffect);

var _focusLock = require('focus-lock');

var _focusLock2 = _interopRequireDefault(_focusLock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FocusTrap = function FocusTrap(_ref) {
  var children = _ref.children,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus;
  return _react2.default.createElement(
    'div',
    { onBlur: onBlur, onFocus: onFocus },
    children
  );
};

FocusTrap.propTypes = {
  onBlur: _propTypes2.default.func.isRequired,
  onFocus: _propTypes2.default.func.isRequired,
  children: _propTypes2.default.node.isRequired
};

var lastActiveTrap = 0;
var lastActiveFocus = null;
var activateTrap = function activateTrap() {
  if (lastActiveTrap) {
    var _lastActiveTrap = lastActiveTrap,
        observed = _lastActiveTrap.observed,
        onActivation = _lastActiveTrap.onActivation;

    if (observed && !(0, _focusLock.focusInside)(observed)) {
      onActivation();
      (0, _focusLock2.default)(observed, lastActiveFocus);
    }
    lastActiveFocus = document.activeElement;
  }
};

function reducePropsToState(propsList) {
  return propsList.filter(function (_ref2) {
    var disabled = _ref2.disabled;
    return !disabled;
  }).slice(-1)[0];
}

function handleStateChangeOnClient(trap) {
  lastActiveTrap = trap;
  if (trap) {
    _focusLock.tabHook.attach(trap.observed, trap.sandboxed);
    activateTrap();
    setImmediate(activateTrap);
  } else {
    _focusLock.tabHook.detach();
    lastActiveFocus = null;
  }
}

exports.default = (0, _reactSideEffect2.default)(reducePropsToState, handleStateChangeOnClient)(FocusTrap);